<?php
/******************************************************************************
** codebase.php
*  Coppermine 1.6.x Plugin - autoapprove. Created by KF to provide automatic approval of uploads 
*  Version 1.0
* @since  1.6.22
******************************************************************************/

// Make sure that this file can't be accessed directly, but only from within the Coppermine user interface
if (!defined('IN_COPPERMINE')) {
    die('Not in Coppermine...');
}

// Define plugin actions here
$thisplugin->add_action('plugin_install', 'autoapprove_install');
$thisplugin->add_action('plugin_uninstall', 'autoapprove_uninstall');
$thisplugin->add_action('plugin_cleanup', 'autoapprove_cleanup');
$thisplugin->add_action('add_file_data_success', 'autoapprove_run');

// Define plugin filters here

// Approve the uploaded file 

function autoapprove_run($file_info) {
     
    global $lang_plugin_autoapprove, $CONFIG;

    if ($CONFIG['autoapprove_enable'] == '1') {
        $query = "SELECT `keyword`  FROM {$CONFIG['TABLE_PICTURES']} AS p INNER JOIN {$CONFIG['TABLE_ALBUMS']} as a ON a.aid = p.aid WHERE `pid` = {$file_info['pid']} LIMIT 1";
        $data = cpg_db_fetch_assoc(cpg_db_query($query));
        if (($data['keyword'] <> '') && ($file_info['approved'] == 'NO')) {
            $keyword_found = stripos($data['keyword'], $CONFIG['autoapprove_keyword']);
            if (is_numeric($keyword_found)) {
                $result =  cpg_db_query("UPDATE {$CONFIG['TABLE_PICTURES']} SET approved='YES' WHERE `pid`={$file_info['pid']}"); 
            }
        }
    }
    return $file_info;
}


function autoapprove_install() {
    global $CONFIG, $lang_plugin_autoapprove, $autoapprove_default; 
    cpg_db_query("INSERT IGNORE INTO {$CONFIG['TABLE_CONFIG']} (`name`, `value`) 
                 VALUES ('autoapprove_enable', {$autoapprove_default}),
                 ('autoapprove_keyword', '{$lang_plugin_autoapprove['autoapprove_keyword_default']}'),
                 ('autoapprove_message', '{$lang_plugin_autoapprove['DefaultMessage']}')
                ");
    return true;
}

function autoapprove_uninstall() {
    global $CONFIG, $lang_plugin_autoapprove, $lang_errors;
    $superCage = Inspekt::makeSuperCage();
    if (!checkFormToken()) {
        cpg_die(ERROR, $lang_errors['invalid_form_token'], __FILE__, __LINE__);
    }
	if ($superCage->post->keyExists('autoapprove_submit') && $superCage->post->keyExists('autoapprove_uninstall_type')) {
		if ($superCage->post->getInt('autoapprove_uninstall_type') == 1) {
            // Delete the plugin config records
            cpg_db_query("DELETE FROM {$CONFIG['TABLE_CONFIG']} WHERE name IN ( 
                        'autoapprove_enable',
                        'autoapprove_keyword', 
                        'autoapprove_message'
                       )");
        }
        return true;
    } else {
        return 1;
    }
}

function autoapprove_cleanup ()  {
	global $lang_common, $superCage, $lang_plugin_autoapprove;

	echo '<form name="cpgform" id="cpgform" action="'.$superCage->server->getEscaped('REQUEST_URI').'" method="post">';
	echo <<<EOT
	<br />{$lang_plugin_autoapprove['uninstall_type']}<br />
	<input type="radio" name="autoapprove_uninstall_type" id="autoapprove_full" value="1" checked="checked" /> 
        <label for="autoapprove_full">{$lang_plugin_autoapprove['uninstall_full']}</label><br />
	<input type="radio" name="autoapprove_uninstall_type" id="autoapprove_partial" value="2"  /> 
        <label for="autoapprove_partial">{$lang_plugin_autoapprove['uninstall_partial']}</label><br />
	<br /><input type="submit" name="autoapprove_submit" value="{$lang_common['continue']}" class="button" style="padding-right:5px;padding-left:5px" />
	</form>
EOT;
}
