<?php
/******************************************************************************
** config.php
*  Coppermine 1.6.x Plugin - autoapprove. Created by KF to provide automatic approval of uploads 
*  Version 1.0
* @since  1.6.22
******************************************************************************/
global $lang_plugin_autoapprove;
// create Inspekt supercage
$superCage = Inspekt::makeSuperCage();

// Make sure that this file can't be accessed directly, but only from within the Coppermine user interface
if (!defined('IN_COPPERMINE')) {
    die('Not in Coppermine...');
}

if (!GALLERY_ADMIN_MODE) {
    cpg_die(ERROR, $lang_errors['access_denied'], __FILE__, __LINE__);
}
$config_changes_counter_checkbox = 0;
$config_changes_counter_raw = 0;
$output_option['autoapprove_enable']  = $CONFIG['autoapprove_enable'];
$output_option['autoapprove_keyword'] = $CONFIG['autoapprove_keyword'];
$output_option['autoapprove_message'] = $CONFIG['autoapprove_message'];
// get sanitized POST parameters
if ($superCage->post->keyExists('submit')) {
    if ($superCage->post->getRaw('submit') == $lang_plugin_autoapprove['submit']) {
        // Define the sanitization patterns
        $sanitization_array = array(
          'autoapprove_enable'   => array('type' => 'checkbox', 'min' => '0', 'max' => '1'),
          'autoapprove_keyword'  => array('type' => 'raw', 'regex' => '/^[A-Za-z ]+$/'),
          'autoapprove_message'  => array('type' => 'raw', 'regex' => '/^[A-Za-z ]+$/'),
        );
        foreach ($sanitization_array as $san_key => $san_value) {   
            if ($san_value['type'] == 'checkbox') { // type is checkbox 
                $stored_setting = $CONFIG[$san_key];  
                if ($superCage->post->keyExists($san_key)) {
                    if ($superCage->post->getInt($san_key) <= $san_value['max'] && $superCage->post->getInt($san_key) >= $san_value['min'] && strval($superCage->post->getInt($san_key)) != $stored_setting) {
                        $new_setting = strval($superCage->post->getInt($san_key));
                        $config_changes_counter_checkbox++;
                    }
                } else {  // blank which is 0 i.e. don't display
                    if ($stored_setting <> '0') {   // if stored setting isn't already 0, update it. Otherwise leave unchanged
                        $new_setting = '0';
                        $config_changes_counter_checkbox++;
                    }
                }
                if ($config_changes_counter_checkbox > 0) {
                    cpg_db_query("UPDATE {$CONFIG['TABLE_CONFIG']} SET value='{$new_setting}' WHERE name='{$san_key}'");
                    $output_option[$san_key] = $new_setting; 
                }
            } else { 
                if ($san_value['type'] == 'raw') {  // type is text
                    $text_value = $superCage->post->getRaw($san_key);
                    if ($text_value == $CONFIG[$san_key]) {
                        $output_option[$san_key] = $CONFIG[$san_key];
                    } else {
                        $config_changes_counter_raw++;
                        $output_option[$san_key] = $text_value;
                        cpg_db_query("UPDATE {$CONFIG['TABLE_CONFIG']} SET value='{$text_value}' WHERE name='{$san_key}'"); 
                    } 
                }
            }
        }
    }
}

// display config page
$submit_icon = cpg_fetch_icon('ok', 1);

// Set the option output stuff for the settings
$output_option['autoapprove_enable']  = ($output_option['autoapprove_enable']=='1') ? 'checked="checked"' : '';

if ($superCage->post->keyExists('submit')) {
    if (($config_changes_counter_raw + $config_changes_counter_checkbox) > 0) {
        msg_box('', $lang_plugin_autoapprove['update_success'], '', '', 'success');
    } else {
        msg_box('', $lang_plugin_autoapprove['no_changes'], '', '', 'info');
    }
}

// Identify the plugin being configured
starttable('100%', sprintf($lang_plugin_autoapprove['configure_x'], $lang_plugin_autoapprove['plugin_name']), 3, 'cpg_zebra');

echo <<<EOT
    <!-- insert config option form code start -->
    <tr>
		<td class="tableb" width="40%">
            <label for="autoapprove_enable" class="clickable_option">{$lang_plugin_autoapprove['autoapprove_enable']}</label>
        </td>
        <td>
            <input type="checkbox" name="autoapprove_enable" id="autoapprove_enable" class="checkbox" value="1" {$output_option['autoapprove_enable']}/>
            <label for="autoapprove_enable" class="clickable_option">{$lang_plugin_autoapprove['yes']}</label>
        </td>
    </tr>
	<tr>
        <td valign="top" style="vertical-align:top">
            {$lang_plugin_autoapprove['autoapprove_keyword']}{$lang_plugin_autoapprove['autoapprove_keyword_default']}<BR>
            {$lang_plugin_autoapprove['autoapprove_keyword2']}
        </td>
        <td>
            <textarea name="autoapprove_keyword" id="autoapprove_keyword" class="textinput" rows="1" maxlength="20" />{$output_option['autoapprove_keyword']}</textarea>
        </td>
    </tr>
 	<tr>
        <td valign="top" style="vertical-align:top">
            {$lang_plugin_autoapprove['autoapprove_message']} <br>
            {$lang_plugin_autoapprove['autoapprove_message_part2']}
        </td>
        <td>
            <textarea name="autoapprove_message" id="autoapprove_message" class="textinput" rows="5" maxlength="400" style="width:100%" />{$output_option['autoapprove_message']}</textarea>
        </td>
    </tr>
    <!-- insert config option form code end -->
    <tr>
		<td class="tableb" width="40%">
        </td>
        <td class="tablef" colspan="3">
            <button type="submit" class="button" style="text-align:center" name="submit" value="{$lang_plugin_autoapprove['submit']}">{$submit_icon}{$lang_plugin_autoapprove['submit']}</button>
        </td>
    </tr>
EOT;

endtable();

//EOF
